diff -Naur --exclude=CVS --exclude=configs linux/hpc/ucache.c linux-openmosix/hpc/ucache.c
--- linux/hpc/ucache.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/hpc/ucache.c	2002-12-03 06:16:46.000000000 +0100
@@ -0,0 +1,1452 @@
+/* All changes since Feb 12, 2002 copyright by Moshe Bar
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * Author(s): Moshe Bar, Amnon Shiloh.
+ */
+/* needs adapting for ia64, especially pointer arithmetics */
+
+
+#include <linux/sched.h>
+#include <linux/hpc.h>
+#include <hpc/defs.h>
+#include <hpc/protocol.h>
+#include <hpc/comm.h>
+#include <linux/smp_lock.h>
+#include <linux/mm.h>
+#include <linux/pagemap.h>
+#include <asm/uaccess.h>
+#include <linux/slab.h>
+#include <linux/stddef.h>
+#include <hpc/debug.h>
+#include <hpc/routines.h>
+#include <hpc/balance.h>
+
+#define	breakpoint1(x,a)	do {} while(0)
+#define	breakpoint(x)	breakpoint1(x, 0)
+
+#define	CACHE_ENTRIES	10
+
+struct cblock
+{
+	/*
+	 * DIRTY but useful NOTE: we actually rely on having at least 3
+	 * longwords before the data! (so don't make it less)
+         * in ohter words; don't change this
+	 */
+	unsigned long offset;
+	int len;
+	int count;
+	char data[1];
+};
+
+struct data_cache
+{
+	short first;			/* first entry in list, -1 = NONE */
+	short free;			/* first entry in freelist, -1 = NONE */
+	short next[CACHE_ENTRIES];	/* next on list of entries, -1=none */
+	short prev[CACHE_ENTRIES];	/* prev on list of entries, -1=none */
+	char type[CACHE_ENTRIES];	/* see below */
+	unsigned long addr[CACHE_ENTRIES];	/* start address */
+	unsigned long len[CACHE_ENTRIES];	/* end address */
+	struct cblock *bp[CACHE_ENTRIES]; /* where data (if any) is held */
+};
+
+/* types: */
+
+#define	WRITEABLE	1	/* data available from user to kernel */
+#define	WRITEDATA	2	/* data in cache from user to kernel */
+#define WRITE_STATUS	(WRITEABLE|WRITEDATA)	/* user ==> kernel */
+#define	READABLE	4	/* user address valid for reading */
+#define	READDATA	8	/* data for user cached */
+#define	READ_STATUS	(READABLE|READDATA)	/* kernel ==> user */
+#define	SKIP_MARK	16
+
+#define	END_MARK	(-1)
+
+#define	MAX_POSITIVE	0x7ffffffe	/* max value to return in *non_cache */
+#define	MAX_SEGMENT	32768
+#define	READ_SEND_THRESHOLD	MAX_SEGMENT
+
+extern char *pack_read_cache_data(int *);
+
+struct cblock *
+cblock_alloc(unsigned long offset, int len)
+{
+	struct cblock *cb;
+
+	if((cb = kmalloc(len + offsetof(struct cblock, data[0]), GFP_NOIO)))
+	{
+		cb->offset = offset;
+		cb->len = len;
+		cb->count = 1;
+	}
+	return(cb);
+}
+
+int
+alloc_ucache(void)
+{
+	struct mosix_task *m = &current->mosix;
+	register struct data_cache *d;
+	register unsigned int i;
+
+	if(!(d = m->ucache))
+	{ 
+		/* + * Specfic rules for how to decide which mem_flags to use:
+		 + *
+		 + *    - start_xmit, timeout, and receive methods of network drivers must
+		 + *      use GFP_ATOMIC (spinlock)
+		 + *    - queuecommand methods of scsi drivers must use GFP_ATOMIC (spinlock)
+		 + *    - If you use a kernel thread with a network driver you must use
+		 + *      GFP_NOIO, unless b) or c) apply
+		 + *    - After you have done a down() you use GFP_KERNEL, unless b) or c)
+		 + *      apply or your are in a storage driver's block io path
+		 + *    - probe and disconnect use GFP_KERNEL unless b) or c) apply
+		 + *    - Changing firmware on a running storage or net device uses
+		 + *      GFP_NOIO, unless b) or c) apply. In this case we have to use NOIO */
+		m->ucache = kmalloc(sizeof (struct data_cache), GFP_NOIO);
+		if(!(d = m->ucache))
+			return(0);
+	}
+	/* on free list */
+	d->first = END_MARK;
+	d->free = 0;
+	for(i = 0 ; i < CACHE_ENTRIES ; i++)
+	{
+		d->next[i] = i+1;
+		d->prev[i] = i-1;
+		d->bp[i] = NULL;
+	}
+	d->next[CACHE_ENTRIES-1] = END_MARK;
+	d->prev[0] = END_MARK;
+	breakpoint("ucache allocated");
+	return(1);
+}
+
+inline void
+write_read_cache(struct data_cache *d, int ent)
+{
+	struct user_copy_h u;
+	register struct cblock *bp = d->bp[ent];
+	caddr_t from = &bp->data[d->addr[ent] - bp->offset];
+	int dflags = current->mosix.dflags;
+
+	breakpoint1("write_read_cache, entry %d", ent);
+	u.addr = (char *)d->addr[ent];
+	u.size = d->len[ent];
+	if(dflags & DDEPUTY)
+		comm_send(DEP_DATA_TO_USER, &u, sizeof(u), from, u.size, 0);
+	else if(!(dflags & DFINISHED))
+		copy_to_user(u.addr, from, u.size);
+}
+
+void
+free_ucache(void)
+{
+	register struct data_cache *d = current->mosix.ucache;
+	register int i;
+	struct cblock *cb;
+
+	if(d)
+	{
+		breakpoint("free ucache");
+		for(i = d->first ; i != END_MARK ; i = d->next[i])
+		if((cb = d->bp[i]))
+		{
+			if(d->type[i] & READDATA)
+				write_read_cache(d, i);
+			if(--cb->count == 0)
+				kfree(cb);
+		}
+		kfree(d);
+		current->mosix.ucache = NULL;
+	}
+}
+
+int
+alloc_ucache_entry(struct data_cache *d, int after, int type,
+						unsigned long addr, int len)
+{
+	int ent = d->free;
+	int nex;
+
+	if(ent == END_MARK)
+		return(END_MARK);
+	d->free = d->next[ent];
+	if(d->free != END_MARK)
+		d->prev[d->free] = END_MARK;
+	d->type[ent] = type;
+	d->addr[ent] = addr;
+	d->len[ent] = len;
+	d->bp[ent] = NULL;
+	d->prev[ent] = after;
+	nex = d->next[ent] = (after == END_MARK) ? d->first : d->next[after];
+	if(after == END_MARK)
+		d->first = ent;
+	else
+		d->next[after] = ent;
+	if(nex != END_MARK)
+		d->prev[nex] = ent;
+	d->next[ent] = nex;
+	breakpoint1("allocated entry #%d", ent);
+	return(ent);
+}
+
+void
+free_ucache_entry(struct data_cache *d, int ent)
+{
+	struct cblock *cb;
+
+	if(ent == END_MARK)
+		return;
+	if(d->type[ent] & READDATA)
+		write_read_cache(d, ent);
+	if((cb = d->bp[ent]) && --cb->count == 0)
+		kfree(cb);
+	d->bp[ent] = NULL;
+
+	if(d->next[ent] != END_MARK)
+		d->prev[d->next[ent]] = d->prev[ent];
+	if(d->prev[ent] == END_MARK)
+		d->first = d->next[ent];
+	else
+		d->next[d->prev[ent]] = d->next[ent];
+	d->prev[ent] = END_MARK;
+	d->next[ent] = d->free;
+	d->free = ent;
+	breakpoint1("freed entry #%d", ent);
+}
+
+void
+data_was_read(struct data_cache *d, int ent)
+{
+	unsigned long beg, end;
+	int prev, next;
+	unsigned int newlen;
+	/*
+	 * The data from this entry was read and brought back to the REMOTE,
+	 * so it can be discarded - however, if this entry can bridge its
+	 * neighbours on both sides (a common case), it is even better to
+	 * do it and save 2 entries rather than 1!
+	 */
+	d->type[ent] &= ~(READDATA|WRITEDATA);
+	d->type[ent] |= READABLE;
+	if((prev = d->prev[ent]) != END_MARK &&
+		(next = d->next[ent]) != END_MARK &&
+		(d->type[prev] & ~SKIP_MARK) == d->type[ent] &&
+		(d->type[next] & ~SKIP_MARK) == d->type[ent] &&
+		d->bp[prev] == d->bp[ent] &&
+		d->bp[next] == d->bp[ent] &&
+		(beg = d->addr[ent]) == d->addr[prev] + d->len[prev] &&
+		(end = beg + d->len[ent]) == d->addr[next] &&
+		(newlen = end + d->len[next] - d->addr[prev]) <= MAX_POSITIVE)
+	{
+		breakpoint1("data_was_read: Joining around %d", ent);
+		free_ucache_entry(d, ent);
+		/* mostly one non-READDATA entry can have a SKIP_MARK */
+		if(d->type[next] & SKIP_MARK)
+		{
+			d->addr[next] = d->addr[prev];
+			d->len[next] = newlen;
+			free_ucache_entry(d, prev);
+		}
+		else
+		{
+			d->len[prev] = newlen;
+			free_ucache_entry(d, next);
+		}
+	}
+	else if(!(d->type[ent] & WRITEABLE))	/* still of a value... */
+		free_ucache_entry(d, ent);
+}
+
+/*
+ * Flush only the read-cache:
+ * 
+ * mostly, there is no more than one entry involved, so we use
+ * "write_read_cache" to send it back, but if there is more than one entry,
+ * all entries must be packed to minimize the number of communication packets
+ * (unless we are no longer DEPUTY - then we also use "write_read_cache").
+ *
+ * Any entry(ies) marked SKIP_MARK are not flushed.
+ */
+void
+flush_read_cache(void)
+{
+	register struct data_cache *d = current->mosix.ucache;
+	register int i;
+	int j = 0;		/* only for the compiler's sake */
+	int n;
+	char *p;
+
+	if(!d)
+		return;
+	breakpoint("flushing read_cache");
+	if(!(current->mosix.dflags & DDEPUTY))
+	{
+		one_by_one:
+		for(i = d->first ; i != END_MARK ; i = d->next[i])
+		if((d->type[i] & (READDATA|SKIP_MARK)) == READDATA)
+		{
+			write_read_cache(d, i);
+			data_was_read(d, i);
+			goto one_by_one;	/* list may be scrambled */
+		}
+		breakpoint("read cache flushed one by one");
+		return;
+	}
+	for(n = 0 , i = d->first ; i != END_MARK ; i = d->next[i])
+	if((d->type[i] & (READDATA|SKIP_MARK)) == READDATA)
+	{
+		if(!n++)
+			j = i;
+	}
+	if(!n)
+	{
+		breakpoint("there was no read-cache to free");
+		return;
+	}
+	if(n == 1)
+	{
+		write_read_cache(d, j);
+		data_was_read(d, j);
+		breakpoint("there was only one read-cache to free");
+		return;
+	}
+	if((p = pack_read_cache_data(&n)))
+	{
+		comm_send(DEP_CACHE_READ_DATA, NULL, 0, p, n, 0);
+		kfree(p);
+		breakpoint("freed multiple read-cache entries");
+	}
+	else	/* no memory -- too bad: */
+		goto one_by_one;
+}
+
+/*
+ * free some entry except the one we are dealing with,
+ * obtaining at least one free entry.
+ * Because CACHE_ENTRIES > 1, there is ALWAYS SOMETHING to free,
+ * but priorities may apply
+ * (the lower, the dearer; the higher, the more disposable).
+ */
+void
+free_some_entry_except(struct data_cache *d, int not_this)
+{
+	register int i;
+	int pri = -1, p;
+	int e = END_MARK;
+	struct cblock *cb;
+	unsigned int n = 0;
+	unsigned int m = 0;
+
+	breakpoint1("free_some_entry_except #%d", not_this);
+	/*
+	 * first try to flush all complete READDATA entries:
+	 * if all the cblock was filled, all operations on that region were
+	 * very likely completed:
+	 */
+	for(i = d->first ; i != END_MARK ; i = d->next[i])
+	if(d->type[i] & READDATA)
+	{
+		m++;
+		if(i == not_this || d->addr[i] != (cb = d->bp[i])->offset ||
+			d->len[i] != cb->len)
+			d->type[i] |= SKIP_MARK;
+		else if(!n++)
+			e = i;
+	}
+	if(n == 1)
+	{
+		write_read_cache(d, e);
+		d->type[not_this] |= SKIP_MARK;	/* (even if not READDATA) */
+		data_was_read(d, e);
+	}
+	else if(n)	/* should be pretty rare, but still save on packets */
+		flush_read_cache();
+	if(m)
+	for(i = d->first ; i != END_MARK ; i = d->next[i])
+		d->type[i] &= ~SKIP_MARK;
+	if(d->free != END_MARK)
+		return;
+	again:
+	for(e = END_MARK , i = d->first ; i != END_MARK ; i = d->next[i])
+	if(i != not_this)
+	{
+		/* PRIORITY POLICY:
+		 * generally, WRITEDATA is more valuable than READDATA because it would
+		 * be a pity to lose the already existing data.
+		 * In both cases, the SHORTER the data the more valuable, because
+		 * the extra communication would cost more per-byte.
+		 * (remember that the data is incomplete within its cblock -
+		 * when complete, it can be joined with other entries)
+		 * Also, READABLE is more valuable than WRITEABLE because more
+		 * system-calls bring data to the user in tiny parts.
+		 * In both cases, the LONGER the data the more valuable, because we
+		 * have more helpful information.
+		 * Data segments are between 1-MAX_SEGMENT size
+		 * (READABLE|WRITEABLE can be more)
+		 * In the mixed cases (both data and pure information),
+		 * there is no easy way to evaluate, so we provide fixed values.
+		 */
+		switch(d->type[i])
+		{
+			/* throwing data - the shorter the dearer */
+		case READDATA:
+			p = MAX_SEGMENT/2 + 40 + d->len[i] / (MAX_SEGMENT / 10);
+			break;
+		case WRITEDATA:
+			p = MAX_SEGMENT/2 + 30 + d->len[i] / (MAX_SEGMENT / 10);
+			break;
+		case WRITEDATA|READDATA:
+			p = MAX_SEGMENT/2 + 20 + d->len[i] / (MAX_SEGMENT / 10);
+			break;
+			/* mixed case: hard, so just a fixed value: */
+		case READDATA|WRITEABLE:
+			p = MAX_SEGMENT/2 + 39;
+			break;
+		case WRITEDATA|READABLE:
+			p = MAX_SEGMENT/2 + 29;
+			break;
+			/* declaration only - the longer the more valuable: */
+		case WRITEABLE:
+			p = MAX_SEGMENT / d->len[i];
+			break;
+		case READABLE:
+			p = MAX_SEGMENT / (2 * d->len[i]);
+			break;
+		case READABLE|WRITEABLE:
+			p = MAX_SEGMENT * 2 / (3 * d->len[i]);
+			break;
+		default:
+			printk("free_some_entry_except: type %d encountered\n", d->type[i]);
+			p = 1;
+		}
+		if(!d->bp[i] || d->bp[i] != d->bp[not_this] ||
+		   d->addr[i] < d->addr[not_this])
+			p++;
+		if(p > pri)
+		{
+			pri = p;
+			e = i;
+		}
+	}
+	if(e == END_MARK)
+		panic("free_some_entry_except: none found");
+	if(d->type[e] & READDATA)
+	{
+		write_read_cache(d, e);
+		d->type[not_this] |= SKIP_MARK;
+		data_was_read(d, e);
+		d->type[not_this] &= ~SKIP_MARK;
+		if(d->free == END_MARK)
+			goto again;
+	}
+	else
+		free_ucache_entry(d, e);
+}	
+
+void
+split_ucache(int ent, unsigned long at, int back)
+{
+	register struct data_cache *d = current->mosix.ucache;
+	int e2;
+	struct cblock *cb;
+
+	breakpoint1("split entry at %X", at);
+	if(d->free == END_MARK)
+		free_some_entry_except(d, ent);
+	if(back)
+	{
+		e2 = alloc_ucache_entry(d, d->prev[ent], d->type[ent],
+			d->addr[ent], at - d->addr[ent]);
+		d->len[ent] = d->addr[ent] + d->len[ent] - at;
+		d->addr[ent] = at;
+	}
+	else
+	{
+		e2 = alloc_ucache_entry(d, ent, d->type[ent], at,
+			d->addr[ent] + d->len[ent] - at);
+		d->len[ent] = at - d->addr[ent];
+	}
+	if((cb = d->bp[ent]))
+	{
+		d->bp[e2] = cb;
+		cb->count++;
+	}
+	breakpoint1("Split of Entry #%d Complete", ent);
+}
+
+int
+obtain_ucache_block(struct data_cache *d, int ent, unsigned long at)
+{
+	if(d->len[ent] > MAX_SEGMENT)
+	{
+		if(at - d->addr[ent] < MAX_SEGMENT)
+			split_ucache(ent, d->addr[ent] + MAX_SEGMENT, 0);
+		else if(at + MAX_SEGMENT >= d->addr[ent] + d->len[ent])
+			split_ucache(ent, (d->type[ent] & READABLE) ? at :
+				d->addr[ent] + d->len[ent] - MAX_SEGMENT, 1);
+		else
+		{
+			split_ucache(ent, at, 1);
+			split_ucache(ent, at + MAX_SEGMENT, 0);
+		}
+	}
+	return((d->bp[ent] = cblock_alloc(d->addr[ent], d->len[ent])) != NULL);
+}
+
+void
+flush_ucache(void)
+{
+	register struct data_cache *d = current->mosix.ucache;
+	register unsigned int i;
+	struct cblock *cb;
+
+	if(!d || d->first == END_MARK)
+		return;
+	breakpoint("flush_ucache");
+	if(!(current->mosix.dflags & DREMOTE)) /* save time - no READDATA */
+		flush_read_cache();
+	for(i = 0 ; i < CACHE_ENTRIES ; i++)
+	if((cb = d->bp[i]))
+	{
+		if(--cb->count == 0)
+			kfree(cb);
+		d->bp[i] = NULL;
+	}
+	for(i = 0 ; i < CACHE_ENTRIES ; i++)
+	{
+		d->next[i] = i+1;
+		d->prev[i] = i-1;
+	}
+	d->first = END_MARK;
+	d->free = 0;
+	d->next[CACHE_ENTRIES-1] = END_MARK;
+	d->prev[0] = END_MARK;
+}
+
+int
+ask_for_write_data(int ent)
+{
+	register struct data_cache *d = current->mosix.ucache;
+	struct cblock *cb = d->bp[ent];
+	struct user_copy_h u;
+	int result;
+
+	breakpoint1("ask_for_write_data on entry #%d", ent);
+	u.addr = (char *)d->addr[ent];
+	u.size = d->len[ent];
+	u.verify = 0;	/* we wouldn't ask if we had no WRITEABLE! */
+	if(deputy_request(DEP_COPY_FROM_USER, &u, sizeof(u), NULL, 0, 0,
+		(void **)&result, -sizeof(result)))
+		return(0);
+	if(result)
+	{
+		comm_flushdata(COMM_ALLDATA);
+		return(0);
+	}
+	if(comm_copydata(&cb->data[d->addr[ent] - cb->offset], u.size, 0))
+		return(0);
+	d->type[ent] &= ~WRITE_STATUS;
+	d->type[ent] |= WRITEDATA;
+	return(1);
+}
+
+void
+try_to_merge_ucache(int ent)
+{
+	register struct data_cache *d = current->mosix.ucache;
+	int o;
+	int t = d->type[ent];
+	struct cblock *cb = d->bp[ent];
+
+	if((o = d->prev[ent]) != END_MARK &&
+		d->type[o] == t && d->bp[o] == cb &&
+		d->addr[o] + d->len[o] == d->addr[ent] &&
+		d->len[ent] + d->len[o] <= MAX_POSITIVE)
+	{
+		d->addr[ent] = d->addr[o];
+		d->len[ent] += d->len[o];
+		d->type[o] &= ~READDATA;
+		free_ucache_entry(d, o);
+		breakpoint1("Merged #%d with previous", ent);
+	}
+	if((o = d->next[ent]) != END_MARK &&
+		d->type[o] == t && d->bp[o] == cb &&
+		d->addr[ent] + d->len[ent] == d->addr[o] &&
+		d->len[ent] + d->len[o] <= MAX_POSITIVE)
+	{
+		d->len[ent] += d->len[o];
+		d->type[o] &= ~READDATA;
+		free_ucache_entry(d, o);
+		breakpoint1("Merged #%d with next", ent);
+	}
+}
+
+inline int
+find_non_cached(struct data_cache *d, int types, unsigned int addr, int max)
+{
+	register int i;
+	int nc;
+
+	if(!max)
+		return(0);
+	breakpoint1("Finding non-cached from address %X", addr);
+	for(i = d->first ; i != END_MARK &&
+		(!(d->type[i] & types) || d->addr[i] + d->len[i] <= addr) ;
+		i = d->next[i])
+		;
+	if(i == END_MARK)
+		return(max);
+	if((nc = d->addr[i] - addr) > MAX_POSITIVE)
+		return(MAX_POSITIVE);
+	if(nc > max)
+		nc = max;
+	breakpoint1("non-cached=0x%X", nc);
+	return(nc);
+}
+
+int
+copy_from_cache(char *to, unsigned long from, int len, int *non_cache)
+{
+	register struct data_cache *d = current->mosix.ucache;
+	int rlen = (len < 0 ? -len : len);
+	unsigned int orlen = rlen;
+	register int i;
+	struct cblock *cb;
+	char *cp;
+	int n;
+	int zero_found = 0;
+
+	if(!d)
+	{
+		none:
+		*non_cache = rlen;
+#ifdef WHY_NOT_CACHED
+if(ds_debug & DSDEB_NOTCACHED){printk("%X(%x) not in cache!",(int)from,rlen);mosix_panic("Why");}
+#endif /* WHY_NOT_CACHED */
+		return(0);
+	}
+	for(i = d->first ; i != END_MARK &&
+		(!(d->type[i] & (WRITE_STATUS|READDATA)) ||
+			d->addr[i] + d->len[i] <= from) ;
+		i = d->next[i])
+		;
+	if(i == END_MARK)
+		goto none;
+	if(d->addr[i] > from)
+	{
+		n = d->addr[i] - from;
+		if(((unsigned int)n) > orlen)
+			n = orlen;
+		*non_cache = n;
+		breakpoint1("copy_from_cache from 0x%X - way before cache", from);
+#ifdef WHY_NOT_CACHED
+if(ds_debug & DSDEB_NOTCACHED){printk("%X(%x) not in cache!",(int)from,rlen);mosix_panic("Why");}
+#endif /* WHY_NOT_CACHED */
+		return(0);
+	}
+	breakpoint1("copy_from_cache from 0x%X - something relevant", from);
+	if(!d->bp[i] && !obtain_ucache_block(d, i, from))
+	{
+		breakpoint("copy_from_cache: failed allocating a cblock");
+		free_ucache_entry(d, i);
+		*non_cache = find_non_cached(d, WRITE_STATUS|READDATA,
+								from, orlen);
+#ifdef WHY_NOT_CACHED
+if(ds_debug & DSDEB_NOTCACHED){printk("%X(%x) not in cache!",(int)from,rlen);mosix_panic("Why");}
+#endif /* WHY_NOT_CACHED */
+		return(0);
+	}
+	if(d->addr[i] + d->len[i] < from + rlen)
+		rlen = d->addr[i] + d->len[i] - from;
+	if(!(d->type[i] & (READDATA|WRITEDATA)) && !ask_for_write_data(i))
+	{
+		breakpoint1("Failed obtaining write-data for entry #%d", i);
+		free_ucache_entry(d, i);
+		rlen = 0;
+	}
+	else
+	{
+		breakpoint1("Fetching 0x%x bytes from cache", rlen);
+		cb = d->bp[i];
+		cp = &cb->data[from - cb->offset];
+		if(len > 0)
+			memcpy(to, cp, rlen);
+		else if(to) /* stop at 0, but include it */
+		{
+			for(n = 0 ; n < rlen ; n++)
+			if((*to++ = *cp++) == '\0')
+			{
+				n++;
+				zero_found = 1;
+				break;
+			}
+			rlen = n;
+		}
+		else	/* called from "strlen_cache" */
+		{
+			for(n = 0 ; n < rlen ; n++)
+			if(*cp++ == '\0')
+			{
+				n++;
+				zero_found = 1;
+				break;
+			}
+			rlen = n;
+		}
+		/* finally, can we rid or shorten this entry? */
+		if(d->type[i] == WRITEDATA &&
+			d->first == i && d->next[i] == END_MARK)
+			/* leave the poor single-entry alone -nothing to lose */
+			/* (some tty routines read TWICE) */
+				;
+		else if(d->type[i] & READ_STATUS)
+		{
+			if(from != d->addr[i])
+				split_ucache(i, from, 1);
+			if(len < d->len[i])
+				split_ucache(i, from + len, 0);
+			d->type[i] &= ~WRITEDATA;
+			if(!(d->type[i] & READDATA))
+			{
+				if(cb && --cb->count == 0)
+					kfree(cb);
+				d->bp[i] = NULL;
+			}
+			try_to_merge_ucache(i);
+			breakpoint1("some (or all) of block #%d was only left for reading", i);
+		}
+		else if(from == d->addr[i] && d->len[i] == rlen)
+		{
+			free_ucache_entry(d, i);
+			breakpoint1("All block #%d was consumed", i);
+		}
+		else
+		{
+			if(from == d->addr[i])
+			{
+				d->addr[i] += rlen;
+				d->len[i] -= rlen;
+			}
+			else if(from + rlen == d->addr[i] + d->len[i])
+				d->len[i] = from - d->addr[i];
+			breakpoint1("some of block #%d was consumed", i);
+		}
+	}
+	if(zero_found)
+	{
+		breakpoint("zero found");
+		*non_cache = -1;
+	}
+	else
+		*non_cache = find_non_cached(d, WRITE_STATUS|READDATA,
+						from+rlen, orlen - rlen);
+#ifdef WHY_NOT_CACHED
+if(*non_cache && !zero_found && (ds_debug & DSDEB_NOTCACHED)){printk("from %X(%x) not in cache!",(int)(from+rlen),orlen-rlen);mosix_panic("Why");}
+#endif /* WHY_NOT_CACHED */
+	return(rlen);
+}
+
+void
+check_whether_to_read_flush(void)
+{
+	register struct data_cache *d = current->mosix.ucache;
+	register int i;
+	int l = 0, n = 0;
+	register struct cblock *cb;
+
+	for(i = d->first ; i != END_MARK ; i = d->next[i])
+	if(d->type[i] & READDATA)
+	{
+		cb = d->bp[i];
+		if(d->len[i] == cb->len && d->addr[i] == cb->offset)
+			l += cb->len;
+		else
+			n += cb->len;
+	}
+	else if(d->type[i] & READABLE)
+		n += d->len[i];
+	if(l >= READ_SEND_THRESHOLD && n >= READ_SEND_THRESHOLD)
+		flush_read_cache();
+}
+
+int
+copy_to_cache(unsigned long to, char *from, int len, int *non_cache)
+{
+	register struct data_cache *d = current->mosix.ucache;
+	unsigned int olen = len;
+	register int i;
+	unsigned int lim;
+	struct cblock *cb;
+
+	if(!d)
+	{
+		none:
+		*non_cache = len;
+#ifdef WHY_NOT_CACHED
+if(ds_debug & DSDEB_NOTCACHED){printk("%X(%x) not in cache!",(int)to,olen);mosix_panic("Why");}
+#endif /* WHY_NOT_CACHED */
+		return(0);
+	}
+	for(i = d->first ; i != END_MARK &&
+		(!(d->type[i] & (READ_STATUS|WRITEDATA)) ||
+			d->addr[i] + d->len[i] <= to) ;
+		i = d->next[i])
+		;
+	if(i == END_MARK)
+		goto none;
+	if(d->addr[i] > to)
+	{
+		if(d->addr[i] - to > olen)
+			*non_cache = olen;
+		else
+			*non_cache = d->addr[i] - to;
+#ifdef WHY_NOT_CACHED
+if(ds_debug & DSDEB_NOTCACHED){printk("%X(%x) not in cache!",(int)to,olen);mosix_panic("Why");}
+#endif /* WHY_NOT_CACHED */
+		return(0);
+	}
+	breakpoint1("copy_to_cache from 0x%X - something relevant", to);
+	if(!d->bp[i] && !obtain_ucache_block(d, i, to))
+	{
+		breakpoint("copy_to_cache: failed allocating a cblock");
+		cant_do_it:
+		free_ucache_entry(d, i);
+		*non_cache = find_non_cached(d, READ_STATUS|WRITEDATA,
+								to, olen);
+		breakpoint1("cant_do_it: *non_cache=%d", *non_cache);
+#ifdef WHY_NOT_CACHED
+if(ds_debug & DSDEB_NOTCACHED){printk("%X(%x) not in cache!",(int)to,olen);mosix_panic("Why");}
+#endif /* WHY_NOT_CACHED */
+		return(0);
+	}
+	if(d->addr[i] != to && !(d->type[i] & READDATA))
+		split_ucache(i, to, 1);
+	lim = d->addr[i] + d->len[i];
+	if(lim != to + len)
+	{
+		if(lim < to + len)
+			len = d->addr[i] + d->len[i] - to;
+		else if(!(d->type[i] & READDATA))
+			split_ucache(i, to + len, 0);
+	}
+	if(!(d->type[i] & READ_STATUS))
+	/* we have user-read permission but not user-write:
+	 * we did need to get thus far to minimize the data-loss,
+	 * but now we must discard this entry.
+	 */
+	{
+		breakpoint("copy_to_cache: Sorry Only read-permission");
+		goto cant_do_it;
+	}
+	breakpoint1("copy_to_cache: copying %d bytes", len);
+	cb = d->bp[i];
+	if(from)
+		memcpy(&cb->data[to - cb->offset], from, len);
+	else	/* called from zero_cache() */
+		memset(&cb->data[to - cb->offset], 0, len);
+	d->type[i] &= ~READ_STATUS;
+	d->type[i] |= READDATA;
+	try_to_merge_ucache(i);
+	if(d->addr[i] == cb->offset && d->len[i] == cb->len)
+		check_whether_to_read_flush();
+	*non_cache = find_non_cached(d, READ_STATUS|WRITEDATA, to + len,
+								olen - len);
+	breakpoint1("copy_to_cache: success, non_cache=%d", *non_cache);
+#ifdef WHY_NOT_CACHED
+if(*non_cache && (ds_debug & DSDEB_NOTCACHED)){printk("%X(%x) not in cache!",(int)(to+len),olen-len);mosix_panic("Why");}
+#endif /* WHY_NOT_CACHED */
+	return(len);
+}
+
+int
+zero_cache(char *to, int len, int *non_cache)
+{
+	return(copy_to_cache((unsigned long)to, NULL, len, non_cache));
+}
+
+int
+strlen_cache(char *addr, int *non_cache)
+{
+	return(copy_from_cache(NULL, (unsigned long)addr, -MAX_POSITIVE,
+								non_cache));
+}
+
+int
+all_in_cache(unsigned long addr, unsigned int size, int writeable)
+{
+	register struct data_cache *d = current->mosix.ucache;
+	register int i;
+	unsigned int limit;
+
+	if(!d || addr + size < addr)	/* no cache or overflow */
+		return(0);
+	for(i = d->first ; i != END_MARK && d->addr[i] + d->len[i] < addr ;
+		i = d->next[i])
+			;
+	limit = addr + size;
+	for(; i != END_MARK ; i = d->next[i])
+	if(d->addr[i] > addr || (writeable && !(d->type[i] & READ_STATUS)))
+		return(0);
+	else if((addr = d->addr[i] + d->len[i]) >= limit)
+		return(1);
+	return(0);
+}
+
+int
+any_in_cache(unsigned long addr, unsigned int size)
+{
+	register struct data_cache *d = current->mosix.ucache;
+	register int i;
+
+	if(!d || addr + size < addr)	/* no cache or overflow */
+		return(0);
+	for(i = d->first ; i != END_MARK && d->addr[i] < addr+size ;
+		i = d->next[i])
+	if(d->addr[i] + d->len[i] > addr &&
+		(d->type[i] & (READDATA|WRITEDATA)))
+		return(1);
+	return(0);
+}
+
+/*
+ * the following routine is only used in the first stage of preparing
+ * a cache, therefore "type" may only be "READABLE", "WRITEABLE", or both
+ * and so must be all entries already in the cache before the call.
+ * this is because its complexity is already enough as it is.
+ * If at some time in the future, new entries are to be produced after
+ * initialization, another routine must be used (or this one expanded).
+ *
+ * Also, note that for simplicity-sake, one of the entries, though very
+ * rare, could be merged to become over the size of MAX_POSITIVE,
+ * so this must be weeded-out later.
+ */
+void
+add_ucache_entry(unsigned long addr, int len, int type)
+{
+	register struct data_cache *d = current->mosix.ucache;
+	register int i;
+	int n;
+	int prev;
+	unsigned long next_addr = 0;
+	unsigned long next_len = 0;
+	char msg[50];
+
+	sprintf(msg, "add_ucache_entry at 0x%X, len=0x%X", (int)addr, len);
+	breakpoint(msg);
+	if(len <= 0 || len > MAX_POSITIVE || addr + len < addr)
+		return;
+	if(!d)
+	{
+		if(alloc_ucache())
+			d = current->mosix.ucache;
+		else
+			return;
+	}
+	next_part:
+	for(prev = END_MARK , i = d->first ;
+		i != END_MARK && d->addr[i] + d->len[i] <= addr ;
+		prev = i , i = d->next[i])
+		;
+	if(i == END_MARK || d->addr[i] > addr + len)
+	{
+		/* no overlap, or even touching */
+		if(prev != END_MARK && d->type[prev] == type &&
+			d->addr[prev] + d->len[prev] == addr)
+			d->len[prev] += len;
+		else
+			alloc_ucache_entry(d, prev, type, addr, len);
+		goto all_done;
+	}
+	if(i != END_MARK && addr + len > d->addr[i] + d->len[i])
+	{
+		/* do some now, the rest later */
+		next_len = addr + len - (d->addr[i] + d->len[i]);
+		next_addr = d->addr[i] + d->len[i];
+		len = next_addr - addr;
+	}
+	if(prev != END_MARK && d->type[prev] == type &&
+		d->addr[prev] + d->len[prev] == addr)
+	{
+		/* increase previous entry */
+		if(i != END_MARK && addr + len >= d->addr[i])
+		{
+			n = d->addr[i] - addr;
+			addr = d->addr[i];
+			len -= n;
+			d->len[prev] += n;
+			try_to_merge_ucache(i);
+		}
+		else
+		{
+			d->len[prev] += len;
+			goto all_done;
+		}
+	}
+	if(i == END_MARK || d->addr[i] > addr + len)
+		alloc_ucache_entry(d, prev, type, addr, len);
+	else if(d->type[i] == type)
+	{
+		if(d->addr[i] > addr)
+		{
+			d->len[i] += d->addr[i] - addr;
+			d->addr[i] = addr;
+		}
+		/* else -- already included, nothing to do */
+	}
+	else if(d->type[i] == (READABLE|WRITEABLE) && d->addr[i] <= addr)
+		; /* nothing to do - already included */
+	else if(d->addr[i] == addr && d->len[i] == len)
+	{
+		d->type[i] |= type;
+		try_to_merge_ucache(i);
+	}
+	else if(d->addr[i] == addr)
+	{
+		split_ucache(i, addr + len, 0);	/* now "i"=new entry */
+		d->type[i] |= type;
+	}
+	else if(d->addr[i] > addr)
+	{
+		alloc_ucache_entry(d, prev, type, addr, d->addr[i] - addr);
+		if(d->addr[i] < addr + len)
+		{
+			if(addr + len < d->addr[i] + d->len[i])
+				split_ucache(i, addr + len, 0);
+			d->type[i] |= type;
+		}
+	}
+	else
+	{
+		split_ucache(i, addr, 1);
+		if(d->addr[i] + d->len[i] != addr + len)
+			split_ucache(i, addr + len, 0);
+		d->type[i] |= type;
+	}
+	if(next_len)
+	{
+		breakpoint1("adding split next segment of %d", next_len);
+		len = next_len;
+		addr = next_addr;
+		next_len = 0;
+		goto next_part;
+	}
+	all_done:
+	breakpoint("after add_ucache_entry");
+}
+
+int
+ucache_ok(unsigned long addr, unsigned long size, int mode)
+{
+	struct vm_area_struct * vma;
+	unsigned long pages;
+	int ok = 0;
+	unsigned int need;
+
+	if (!size || addr+size >= TASK_SIZE || addr+size < addr)
+		return(0);
+
+	down_read(&current->mm->mmap_sem);
+	if (!(vma = find_extend_vma(current->mm, addr)) ||
+							!(vma->vm_flags & mode))
+		goto out;
+	need = ((addr & ~PAGE_MASK) + size + PAGE_SIZE-1) >> PAGE_SHIFT;
+	addr &= PAGE_MASK;
+
+	while(1)
+	{
+		pages = (vma->vm_end - addr) >> PAGE_SHIFT;
+		if(need <= pages)
+			break;
+		need -= pages;
+		addr = vma->vm_end;
+		vma = vma->vm_next;
+		if (!vma || vma->vm_start != addr)
+			goto out;
+		if (!(vma->vm_flags & mode))
+			goto out;
+	}
+	ok = 1;
+	out:
+	up_read(&current->mm->mmap_sem);
+	return(ok);
+}
+
+
+void
+set_read_region(unsigned long addr, unsigned int len)
+{
+	if(!ucache_ok(addr, len, VM_WRITE))
+		return;
+	add_ucache_entry(addr, len, READABLE);
+}
+
+void
+set_write_region(unsigned long addr, unsigned int len)
+{
+	if(!ucache_ok(addr, len, VM_READ))
+		return;
+	add_ucache_entry(addr, len, WRITEABLE);
+}
+
+struct ucache_envelope_entry
+{
+	unsigned long addr;
+	unsigned int len;
+	short type;
+#if MAX_SEGMENT < 65536
+	unsigned short actual_len;
+#else
+	int actual_len;
+#endif
+};
+
+char *
+construct_ucache_envelope(int *len, int *from_user, struct syscall_h *s, char **tofree)
+{
+	int l, n;
+	register struct data_cache *d = current->mosix.ucache;
+	struct ucache_envelope_entry e[CACHE_ENTRIES];
+	register int i;
+	char *envelope, *ep;
+	int ent = END_MARK;	/* only to shut-up the compiler */
+	
+	*tofree = NULL;
+	*len = *from_user = s->simple_data_len = 0;
+	if(!d)
+		return(NULL);
+	rare_again:
+	for(l = n = 0 , i = d->first ; i != END_MARK ; i = d->next[i])
+	{
+		if(d->len[i] > MAX_POSITIVE)	/* rare indeed, but check */
+		{
+			split_ucache(i, d->addr[i] + MAX_POSITIVE, 0);
+			goto rare_again; /* because an entry could be lost */
+		}
+		l += sizeof(struct ucache_envelope_entry);
+		e[n].addr = d->addr[i];
+		e[n].len = d->len[i];
+		if((e[n].type = d->type[i]) & WRITEABLE)
+		{
+			e[n].actual_len = (d->len[i] > MAX_SEGMENT ?
+						MAX_SEGMENT : d->len[i]);
+			l += e[n].actual_len;
+		}
+		else
+			e[n].actual_len = 0;
+		if(!n++)
+		{
+			ent = i;
+			l += sizeof(int);
+		}
+	}
+	if(n == 1)
+	{
+		/* no need for package */
+		breakpoint1("construct_ucache_envelope: only one", l);
+		s->simple_data_addr = d->addr[ent];
+		s->simple_data_len = d->len[ent];
+		s->simple_data_type = d->type[ent];
+		if(d->type[ent] & WRITEABLE)
+		{
+			*from_user = 1;
+			if(s->simple_data_len >= MAX_SEGMENT)
+				*len = MAX_SEGMENT;
+			else
+				*len = s->simple_data_len;
+			s->simple_data_actual = *len;
+			ep = (char *)d->addr[ent];
+		}
+		else
+		{
+			ep = NULL;
+			s->simple_data_actual = 0;
+		}
+		flush_ucache();
+		return(ep);
+	}
+	if(!n || !(envelope = kmalloc(l, GFP_NOIO)))
+	{
+		if(n)
+			breakpoint1("construct_ucache_envelope: could not allocate %d bytes", l);
+		flush_ucache();
+		return(NULL);
+	}
+	*((int *)envelope) = n;
+	memcpy(envelope + sizeof(int), (caddr_t)e, n * sizeof(e[0]));
+	ep = envelope + sizeof(int) + n * sizeof(e[0]);
+	for(i = 0 ; i < n ; i++)
+	if(e[i].actual_len)
+	{
+		if(copy_from_user(ep, (char *)e[i].addr, e[i].actual_len))
+		{
+			/* must be a very serious problem, because area was
+			 * already checked, but could happen on a bad page,
+			 * or if disconnected from DEPUTY, anyway:
+			 */
+			kfree(envelope);
+			flush_ucache();
+			return(NULL);
+		}
+		ep += e[i].actual_len;
+	}
+	breakpoint1("construct_ucache_envelope: made %d bytes", l);
+	flush_ucache();
+	*len = l;
+	*tofree = envelope;
+	s->simple_data_len = -1;
+	return(envelope);
+}
+
+int
+open_ucache_envelope(struct syscall_h *s)
+{
+	int n;
+	register int i, j;
+	int ent;
+	struct ucache_envelope_entry e[CACHE_ENTRIES];
+	struct cblock *cb;
+	register struct data_cache *d;
+	struct mosix_task *m = &current->mosix;
+
+	if(!s->simple_data_len)
+		return(0);
+	if(!(d = m->ucache) && !(alloc_ucache()))
+	{
+		comm_flushdata(COMM_ALLDATA);
+		return(-ENOMEM);
+	}
+	d = m->ucache;
+	if(s->simple_data_len == -1)	/* complex */
+	{
+		if(comm_copydata(&n, sizeof(int), 0))
+		{
+			mosix_panic("open_ucache_envelope: no total");
+			return(-EDIST);
+		}
+		if(n < 1 || n > CACHE_ENTRIES)
+		{
+			printk("n in envelope = %d\n", n);
+			mosix_panic("bad n in envelope");
+			comm_flushdata(COMM_ALLDATA);
+			return(-EDIST);
+		}
+		if(comm_copydata(e, n * sizeof(e[0]), 0))
+		{
+			mosix_panic("open_ucache_envelope: non header");
+			return(-EDIST);
+		}
+	}
+	else
+	{
+		n = 1;
+		e[0].type = s->simple_data_type;
+		e[0].addr = s->simple_data_addr;
+		e[0].len = s->simple_data_len;
+		e[0].actual_len = s->simple_data_actual;
+	}
+	for(ent = END_MARK , i = 0 ; i < n ; i++)
+	       ent = alloc_ucache_entry(d, ent, e[i].type, e[i].addr, e[i].len);
+	for(i = 0 ; i < n ; i++)
+	if(e[i].actual_len)
+	{
+		if(!(cb = cblock_alloc(e[i].addr, e[i].actual_len)))
+		{
+			comm_flushdata(COMM_ALLDATA);
+			return(-ENOMEM);
+		}
+		if(comm_copydata(cb->data, e[i].actual_len, 0))
+		{
+			printk("open_ucache_envelope: copy failed\n");
+			kfree(cb);
+			return(-EDIST);
+		}
+		/* find all entries to share the block: */
+		for(j = d->first ; j != END_MARK ; j = d->next[j])
+		if(d->type[j] & WRITEABLE)
+		{
+			if(d->addr[j] >= e[i].addr + e[i].actual_len ||
+				d->addr[j] + d->len[j] <= e[i].addr)
+				continue;
+			if(d->addr[j] < e[i].addr)
+				split_ucache(j, e[i].addr, 1);
+			if(d->addr[j] + d->len[j] > e[i].addr + e[i].actual_len)
+				split_ucache(j, e[i].addr + e[i].actual_len, 0);
+			d->bp[j] = cb;
+			cb->count++;
+			d->type[j] &= ~WRITEABLE;
+			d->type[j] |= WRITEDATA;
+		}
+		if(--cb->count == 0)
+			kfree(cb);
+	}
+	breakpoint("opened_ucache_envelope");
+	return(0);
+}
+
+struct read_cache_header
+{
+	unsigned long addr;
+	unsigned int len;
+};
+
+/*
+ * Attempt to send the data directly whenever there is only one entry.
+ */
+char *
+deputy_pack_read_cache_data(int *len, struct syscall_ret_h *r, char **tofree)
+{
+	register struct data_cache *d = current->mosix.ucache;
+	register int i;
+	int f = END_MARK;
+	char *result;
+	struct cblock *cb;
+
+	*tofree = NULL;
+	*len = r->simple_data_len = 0;
+	if(!d || d->first == END_MARK)
+		return(NULL);
+	for(i = d->first ; i != END_MARK ; i = d->next[i])
+	if((d->type[i] & (READDATA|SKIP_MARK)) == READDATA)
+	{
+		if(f != END_MARK)
+		{
+			/* more than one entry - do it the long way */
+			result = pack_read_cache_data(len);
+			if(result)	/* (could still fail on memory) */
+			{
+				r->simple_data_len = -1;
+				*tofree = result;
+			}
+			flush_ucache();
+			return(result);
+		}
+		else
+			f = i;
+	}
+	if(f == END_MARK)
+	{
+		flush_ucache();
+		return(NULL);
+	}
+	/* OK: Just one READDATA entry "f" */
+	r->simple_data_addr = d->addr[f];
+	*len = r->simple_data_len = d->len[f];
+	cb = d->bp[f];
+	result = &cb->data[r->simple_data_addr - cb->offset];
+	d->bp[f] = NULL;
+	*tofree = (char *)cb;
+	d->type[f] &= ~(READDATA|WRITEDATA);
+	if(!(d->type[f] & WRITEABLE))
+		free_ucache_entry(d, f);
+	breakpoint1("deputy_pack_read_cache_data: One entry found/used (%d)",f);
+	flush_ucache();
+	return(result);
+}
+
+char *
+pack_read_cache_data(int *len)
+{
+	int l, n;
+	register struct data_cache *d = current->mosix.ucache;
+	struct read_cache_header e[CACHE_ENTRIES];
+	caddr_t from[CACHE_ENTRIES];
+	register int i;
+	char *package, *ep;
+	struct cblock *cb;
+	
+	if(!d || d->first == END_MARK)
+	{
+		*len = 0;
+		return(NULL);
+	}
+	for(l = n = 0 , i = d->first ; i != END_MARK ; i = d->next[i])
+	if((d->type[i] & (READDATA|SKIP_MARK)) == READDATA)
+	{
+		cb = d->bp[i];
+		from[n] = &cb->data[d->addr[i] - cb->offset];
+		e[n].addr = d->addr[i];
+		l += sizeof(e[0]) + (e[n].len = d->len[i]);
+		if(!n++)
+			l += sizeof(int);
+	}
+	if(!n || !(package = kmalloc(l, GFP_NOIO)))
+	{
+		breakpoint1("pack_read_cache_data: could not allocate %d bytes", l);
+		*len = 0;
+		return(NULL);
+	}
+	*((int *)package) = n;
+	memcpy(package + sizeof(int), (caddr_t)e, n * sizeof(e[0]));
+	ep = package + sizeof(int) + n * sizeof(e[0]);
+	for(i = 0 ; i < n ; i++)
+	{
+		memcpy(ep, from[i], e[i].len);
+		ep += e[i].len;
+	}
+	*len = l;
+	clear_readdata:
+	for(i = d->first ; i != END_MARK ; i = d->next[i])
+	if((d->type[i] & (READDATA|SKIP_MARK)) == READDATA)
+	{
+		data_was_read(d, i);
+		goto clear_readdata;	/* list may be scrambled */
+	}
+	breakpoint1("pack_read_cache_data: packed %d bytes", *len);
+	return(package);
+}
+
+int
+remote_unpack_read_cache_data(struct syscall_ret_h *r)
+{
+	register int i;
+	int l = 0, n;
+	struct read_cache_header e[CACHE_ENTRIES];
+
+	if(r && !r->simple_data_len)
+		return(0);
+	if(!r || r->simple_data_len == -1)
+	{
+		if(comm_copydata(&n, sizeof(int), 0))
+		{
+			mosix_panic("unpack_read_cache_data: no total");
+			return(-EDIST);
+		}
+		if(n < 1 || n > CACHE_ENTRIES)
+		{
+			printk("n in package = %d\n", n);
+			mosix_panic("bad n in package");
+			comm_flushdata(COMM_ALLDATA);
+			return(-EDIST);
+		}
+		if(comm_copydata(e, n * sizeof(e[0]), 0))
+		{
+			mosix_panic("open_ucache_envelope: non header");
+			return(-EDIST);
+		}
+		l = sizeof(int) + n * sizeof(e[0]);
+	}
+	else
+	{
+		n = 1;
+		e[0].addr = r->simple_data_addr;
+		e[0].len = r->simple_data_len;
+	}
+	for(i = 0 ; i < n ; i++)
+	if(comm_copydata((char *)e[i].addr, e[i].len, 1))
+	{
+		printk("unpack_cache_read_data: copy to user failed\n");
+		comm_flushdata(COMM_ALLDATA);
+		return(-EDIST);
+	}
+	else
+		l += e[i].len;
+	bump_copyout(l);
+	return(0);
+}
+
